<?php

namespace Repository;

use Util\InstanceProvider;
use Teknisa\Model\Traits\TQuery;

class Attachments
{
    use TQuery;

    public function getEntityManager(){
        return InstanceProvider::getEntityManager();
    }

    public function getTaskAttachmentsExceptUploadedBy($issueId, $filter = null) {
        $fileServerUrl = \Util\Utilities::getFileServerFilesUrl();
        $query = <<<SQL
            SELECT '$fileServerUrl' || ATT.FILE_NAME AS FILENAME, ATT.ID, ATT.LABEL, TASK.NAME, 
                    ATT.TYPE_FILE AS FILE_TYPE, TO_CHAR(ATT.CREATED_AT, 'DD/MM/YYYY') AS CREATED_AT,
                    RES.NAME AS CREATED_BY, C.ID AS COMMENT_ID, 'I' AS CALL_TYPE
              FROM ATTACHMENT ATT
              JOIN RESOURCE_T RES ON (RES.ID = ATT.CREATED_BY)
         LEFT JOIN TASK           ON (TASK.ID = ATT.TASK)
         LEFT JOIN COMMENTS C     ON (ATT.COMMENTS = C.ID)
         LEFT JOIN TASK CTA       ON (CTA.ID = C.TASK)
             WHERE (ATT.TASK = :ID     OR C.TASK = :ID)
               AND (TASK.STATUS <> 'D' OR TASK.STATUS IS NULL)
               $filter
          ORDER BY ATT.CREATED_AT
SQL;

        $params = array (
            'ID' => $issueId
        );

        return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $query, $params);
    }

    public function getAllAttachmentsFolder($nrsoliserv,$basicIntranetFileDir, $cdClienteBase,
                                            $isTeknisaFunc,$filename = ''){
        $directorySeparator = DIRECTORY_SEPARATOR;

        $filter = '';

        $filterFolder = '';
        if($filename){
            $filterFolder = "AND $filename = TO_CHAR(LFT.DTALFASETRAM,'YYYYMMDDHH24MISS')";
        }

        $query = <<<SQL
			SELECT '$basicIntranetFileDir'||'$directorySeparator'||LFT.NRSOLISERV||'$directorySeparator'|| TO_CHAR(LFT.DTALFASETRAM,'YYYYMMDDHH24MISS')||'$directorySeparator' AS DIR,
			TO_CHAR(LFT.DTALFASETRAM,'YYYYMMDDHH24MISS') AS FILENAME
			FROM LOGFASETRAM LFT
                 LEFT JOIN OPERADOR OP  ON OP.CDOPERADOR  = LFT.CDOPERADOR
                 LEFT JOIN OPERADOR OPR ON OPR.CDOPERADOR = LFT.CDOPERRESP
                INNER JOIN SOLISERV SOL ON SOL.NRSOLISERV = :NRSOLISERV
                     WHERE LFT.NRSOLISERV = :NRSOLISERV
                     $filterFolder
                     $filter
SQL;
        $params = array(
            'NRSOLISERV' => $nrsoliserv,
            "cdClienteBase" => $cdClienteBase
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}
